#include "structs.h"
#include "regs.h"

/* Menu item definitions */

// File menu
#define IDM_OPEN	1000	// Open ROM...
#define IDM_LOAD	1010	// Load State
#define IDM_SAVE	1020	// Save State
#define IDM_ROM		1030	// ROM Info
#define IDM_EXIT	1040	// Exit

// Options menu
#define IDM_VIDEO	2000	// Video...
#define IDM_AUDIO	2010	// Audio...

// Emulation menu
#define IDM_START	3000	// Start CPU
#define IDM_PAUSE	3010	// Pause CPU
#define IDM_RESET	3020	// Reset CPU
#define IDM_SHOW	3030	// Show Current Instruction

// Debug menu
#define IDM_ENTER	4000	// Enter Debugger...
#define IDM_CLOSE	4010	// Close Debugger
#define IDM_STOP	4020	// Stop on unhandled Opcode

// Help menu
#define IDM_ABOUT	5000	// About

/* Dialog Box items */
#define IDC_ROMNAME 1001
#define IDC_MANUFACTURER 1002
#define IDC_TAB1 1003

LRESULT CALLBACK WndProc(HWND,
						 UINT,
						 WPARAM,
						 LPARAM);

LRESULT CALLBACK ROM(HWND,
					 UINT,
					 WPARAM,
					 LPARAM);

LRESULT CALLBACK Video(HWND,
					   UINT,
					   WPARAM,
					   LPARAM);

LRESULT CALLBACK Audio(HWND,
					   UINT,
					   WPARAM,
					   LPARAM);

LRESULT CALLBACK Debugger(HWND,
						  UINT,
						  WPARAM,
						  LPARAM);

LRESULT CALLBACK About(HWND,
					   UINT,
					   WPARAM,
					   LPARAM);

/* Variables */
static HWND ROMNameHandle=NULL;
static HWND ManufacturerHandle=NULL;
char ROMName[20];
HANDLE RomHandle;
unsigned _int16 Byte_Swap;
char space[20];
DWORD dwRead;
BOOL BS;
unsigned _int32 ClockRate;
unsigned _int32 PC;
unsigned _int32 OldPC;
unsigned _int32 DelayPC;
_int8 ManufacturerCode;
char Manufacturer[20];
OpCode Ops;
char OC[25];
char text[80];
HMENU hMenu;
BOOL STOP_OP=TRUE;
UINT uState;
int zzz;
BOOL huh;
BOOL CPUisRunning=0;
BOOL SHOW=0;
_int32 OpCode;
char title[MAX_PATH+11];

// Allocate 4,194,304B RDRAM
unsigned char RAM[4194304];

unsigned char SP_DMEM[4096];
unsigned char SP_IMEM[4096];
unsigned char SP_MEMreg[32];
unsigned char DPreg[32];
unsigned char DPSreg[16];
unsigned char MIreg[56];
unsigned char VIreg[56];
unsigned char AIreg[24];
unsigned char PIreg[52];
unsigned char RIreg[32];
unsigned char SIreg[28];
unsigned char RDRAMreg[0x28];